package ch.thomson.ucs.alarms;

import ch.thomson.ucs.alarms.client.dao.entries.AlarmHistoryEntry;
import ch.thomson.ucs.alarms.client.dao.entries.AlarmPendingEntry;
import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

public class FaultAlarmVectorHandler extends AlarmVectorHandler {

	public FaultAlarmVectorHandler(PropertyNumericDAO property, int messageListOffset, Descriptor descriptor) throws Exception {
		super(property, messageListOffset, Category.FAULT, descriptor);
	}

	@Override
	public void alarmHasCome(String messageId) throws Exception {
		getAlarmPendingDAO().setEntry(new AlarmPendingEntry(property.getTimeStamp(), messageId, property.getEquipmentName(), category.getName(), descriptor.getName()));
		getAlarmHistoryDAO().setEntry(new AlarmHistoryEntry(property.getTimeStamp(), messageId, property.getEquipmentName(), category.getName(), Descriptor.COME.getName()));		
		getAlarmSumHandler().setSumFault();
	}

	@Override
	public void alarmHasGone(String messageId) throws Exception {
		// Nichts tun
	}
}
