package ch.thomson.ucs.alarms.client.dao;

import java.sql.SQLException;

public interface BasicDAO {
	/**
	 * Sucht den Host selbst auf einem bekannten TINE-Server-Host.
	 * @throws Exception 
	 */
	public void open() throws Exception;
	public void open(String host) throws Exception;
	public void setupTable() throws SQLException;
	public void close();
	public boolean isClosed();
	public void setAutoCommit(boolean autoCommit) throws SQLException;
	public void commit() throws SQLException;
}
