package ch.thomson.ucs.desy.specialfunctions;

public class FlowDifferenceCalculation extends Calculation {

	public FlowDifferenceCalculation(String[] operators, String result) throws Exception {
		super(operators, result);
	}

	@Override
	public float calculate(float[] operators) {
		return operators[0] - (operators[1] + operators[2] + operators[3]);
	}

	@Override
	public int getNumberOfOperators() {
		return 4;
	}
}
