package ch.thomson.ucs.ftdi.ui;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;

import ch.thomson.ucs.ftdi.emf.ftdi.Device;

public class FtdiTreeLabelProvider extends LabelProvider {
	@Override
	public String getText(Object element) {
		if (element instanceof Device) {
			Device category = (Device) element;
			return category.getDescriptor().getProduct();
		}
		return "";
	}

	@Override
	public Image getImage(Object element) {
		if (element instanceof DeviceCategory) {
			return PlatformUI.getWorkbench().getSharedImages()
					.getImage(ISharedImages.IMG_OBJ_FOLDER);
		}
		return PlatformUI.getWorkbench().getSharedImages()
		.getImage(ISharedImages.IMG_OBJ_FILE);
	}
}
