package ch.thomson.swing.graphics;

import javax.swing.SwingConstants;

/**
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public interface IGraphicsOrientation {

	public static final int HORIZONTAL = SwingConstants.HORIZONTAL;
	public static final int VERTICAL = SwingConstants.VERTICAL;

	/**
	 * Gibt die Orientation der Grafik zurck.
	 * 
	 * @return Die Orientation
	 */
	public abstract int getOrientation();

	/**
	 * Setzt die Orientation der Grafik. Es muss ein <b>int</b> Wert bergeben
	 * werden. Dabei ist <em>HORIZONTAL</em> = 0 und <em>VERTICAL</em> = 1;
	 * 
	 * @param orientation als <b>int</b> Wert
	 */
	public abstract void setOrientation(int orientation);

}