package ch.thomson.swing.graphics;

import ch.thomson.swing.graphics.impl.BarGraph;


/**
 * Ein einfacher Bargraph
 * 
 * Mit dieser Klasse kann ein einfacher Bargraph dargestellt werden
 * 
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public interface IMarker {

	public abstract boolean isMarkerVisible();
	public abstract void setMarkerVisible(boolean visible);
	
	public abstract boolean isMarkersVisible(BarGraph.Marker marker);
	public abstract void setMarkersVisible(BarGraph.Marker marker, boolean visible);
	public abstract boolean[] getMarkersVisible();
	public abstract void setMarkersVisible(boolean visible[]);
	
	public abstract double getMarkersPosition(BarGraph.Marker marker);
	public abstract void setMarkersPosition(BarGraph.Marker marker, double position);
	public abstract double[] getMarkersPosition();
	public abstract void setMarkersPosition(double position[]);
	
	public abstract int getMarkerScale();
	public abstract void setMarkerScale(int val);

}