package ch.thomson.swing.graphics;

/**
 * Ein einfacher Bargraph
 * 
 * Mit dieser Klasse kann ein einfacher Bargraph dargestellt werden
 * 
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public interface IScaleLabelProviderConsumer {

	public abstract boolean isScaleLabelVisible();
	public abstract void setScaleLabelVisible(boolean visible);
	
	public abstract IScaleLabelProvider getScaleLabelProvider(int index);
	public abstract void setScaleLabelProvider(int index, IScaleLabelProvider provider);
	public abstract IScaleLabelProvider[] getScaleLabelProvider();
	public abstract void setScaleLabelProvider(IScaleLabelProvider provider[]);

}