package ch.thomson.swing.jlabel;

import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.JLabel;

import ch.thomson.swing.graphics.impl.GraphicsBase;


/**
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public class JLabelBase extends JLabel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected GraphicsBase Base = null;
	
	@Override
	public void paint(Graphics g) {
		Insets NewInsets = getInsets();
		
		if(Base != null){
			Base.setHeight(getHeight()-NewInsets.top - NewInsets.bottom);
			Base.setWidth(getWidth() - NewInsets.left - NewInsets.right);
		}
		super.paint(g);
		if(Base != null){
			Base.paintGraphics(g, NewInsets.left, NewInsets.top);
		}
	}
	
	
	protected void paintLabelComponent(Graphics g){
		super.paint(g);
	}
}

