package ch.thomson.ucs.tine.client.databinding.converters;

import ch.thomson.ucs.tine.client.Property;

public abstract class IndexedScaler extends IndexedConverter {
	
	protected double factor;
	protected double offset;
	
	public IndexedScaler(Object fromType, Object toType, int index, Property property, double scaleMin, double scaleMax) {
		super(fromType, toType, index, property);
		this.factor = 1.0 / (scaleMax - scaleMin);
		this.offset = ((-1.0) * factor) * scaleMin;
	}
}
