package ch.thomson.ucs.tine.databinding.swt.dialogs;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.wb.swt.SWTResourceManager;

import ch.thomson.ucs.tine.databinding.swt.ThSpinner;

public final class WidgetFactory {
	
	/**
	 * @wbp.factory
	 * @wbp.factory.parameter.source style org.eclipse.swt.SWT.BORDER
	 * @wbp.factory.parameter.source layoutData gd_spiFaultUpper
	 */
	public static ThSpinner createSpinner(Composite parent, int style, Object layoutData) {
		ThSpinner spinner = new ThSpinner(parent, style);
		spinner.setFont(SWTResourceManager.getFont("Tahoma", 16, SWT.NORMAL));
		spinner.setLayoutData(layoutData);
		return spinner;
	}
	/**
	 * @wbp.factory
	 * @wbp.factory.parameter.source style org.eclipse.swt.SWT.NONE
	 */
	public static Label createLabel(Composite parent, int style) {
		Label label = new Label(parent, style);
		label.setFont(SWTResourceManager.getFont("Tahoma", 16, SWT.NORMAL));
		label.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label.setText("Upper Fault:");
		return label;
	}
}