/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.statemachine;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Condition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getState <em>State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getMaskInHex <em>Mask In Hex</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getMaskValue <em>Mask Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getFaultDelay <em>Fault Delay</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getMinCondition <em>Min Condition</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getMaxCondition <em>Max Condition</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getLastAlarmMessage <em>Last Alarm Message</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getAlarmMessageKeyMask <em>Alarm Message Key Mask</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getActualConditionStatus <em>Actual Condition Status</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getLastConditionStatus <em>Last Condition Status</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getAlarmMessageKeyMax <em>Alarm Message Key Max</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#getAlarmMessageKeyMin <em>Alarm Message Key Min</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.Condition#isMaskCheckInverted <em>Mask Check Inverted</em>}</li>
 * </ul>
 * </p>
 *
 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition()
 * @model abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='MinMaxOrMaskCondition\r\nassertServerPropertyAndDeviceIsSet'"
 * @generated
 */
public interface Condition extends PropertyDecorator {
	/**
	 * Returns the value of the '<em><b>State</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.client.statemachine.State#getConditions <em>Conditions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>State</em>' container reference.
	 * @see #setState(State)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_State()
	 * @see ch.thomson.ucs.tine.client.statemachine.State#getConditions
	 * @model opposite="conditions" required="true" transient="false"
	 * @generated
	 */
	State getState();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getState <em>State</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>State</em>' container reference.
	 * @see #getState()
	 * @generated
	 */
	void setState(State value);

	/**
	 * Returns the value of the '<em><b>Min Condition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Min Condition</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min Condition</em>' containment reference.
	 * @see #setMinCondition(Setting)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_MinCondition()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Setting getMinCondition();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getMinCondition <em>Min Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Condition</em>' containment reference.
	 * @see #getMinCondition()
	 * @generated
	 */
	void setMinCondition(Setting value);

	/**
	 * Returns the value of the '<em><b>Max Condition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Condition</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Condition</em>' containment reference.
	 * @see #setMaxCondition(Setting)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_MaxCondition()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Setting getMaxCondition();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getMaxCondition <em>Max Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Condition</em>' containment reference.
	 * @see #getMaxCondition()
	 * @generated
	 */
	void setMaxCondition(Setting value);

	/**
	 * Returns the value of the '<em><b>Last Alarm Message</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Last Alarm Message</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Last Alarm Message</em>' attribute.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_LastAlarmMessage()
	 * @model transient="true" changeable="false" derived="true"
	 * @generated
	 */
	String getLastAlarmMessage();

	/**
	 * Returns the value of the '<em><b>Alarm Message Key Mask</b></em>' attribute.
	 * The default value is <code>"UNDEFINED"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Alarm Message Key Mask</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alarm Message Key Mask</em>' attribute.
	 * @see #setAlarmMessageKeyMask(String)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_AlarmMessageKeyMask()
	 * @model default="UNDEFINED"
	 * @generated
	 */
	String getAlarmMessageKeyMask();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getAlarmMessageKeyMask <em>Alarm Message Key Mask</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alarm Message Key Mask</em>' attribute.
	 * @see #getAlarmMessageKeyMask()
	 * @generated
	 */
	void setAlarmMessageKeyMask(String value);

	/**
	 * Returns the value of the '<em><b>Actual Condition Status</b></em>' attribute.
	 * The literals are from the enumeration {@link ch.thomson.ucs.tine.client.statemachine.ConditionStatus}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual Condition Status</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual Condition Status</em>' attribute.
	 * @see ch.thomson.ucs.tine.client.statemachine.ConditionStatus
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_ActualConditionStatus()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	ConditionStatus getActualConditionStatus();

	/**
	 * Returns the value of the '<em><b>Last Condition Status</b></em>' attribute.
	 * The literals are from the enumeration {@link ch.thomson.ucs.tine.client.statemachine.ConditionStatus}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Last Condition Status</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Last Condition Status</em>' attribute.
	 * @see ch.thomson.ucs.tine.client.statemachine.ConditionStatus
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_LastConditionStatus()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	ConditionStatus getLastConditionStatus();

	/**
	 * Returns the value of the '<em><b>Alarm Message Key Max</b></em>' attribute.
	 * The default value is <code>"UNDEFINED"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Alarm Message Key Max</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alarm Message Key Max</em>' attribute.
	 * @see #setAlarmMessageKeyMax(String)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_AlarmMessageKeyMax()
	 * @model default="UNDEFINED"
	 * @generated
	 */
	String getAlarmMessageKeyMax();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getAlarmMessageKeyMax <em>Alarm Message Key Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alarm Message Key Max</em>' attribute.
	 * @see #getAlarmMessageKeyMax()
	 * @generated
	 */
	void setAlarmMessageKeyMax(String value);

	/**
	 * Returns the value of the '<em><b>Alarm Message Key Min</b></em>' attribute.
	 * The default value is <code>"UNDEFINED"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Alarm Message Key Min</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alarm Message Key Min</em>' attribute.
	 * @see #setAlarmMessageKeyMin(String)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_AlarmMessageKeyMin()
	 * @model default="UNDEFINED"
	 * @generated
	 */
	String getAlarmMessageKeyMin();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getAlarmMessageKeyMin <em>Alarm Message Key Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alarm Message Key Min</em>' attribute.
	 * @see #getAlarmMessageKeyMin()
	 * @generated
	 */
	void setAlarmMessageKeyMin(String value);

	/**
	 * Returns the value of the '<em><b>Mask Check Inverted</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mask Check Inverted</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mask Check Inverted</em>' attribute.
	 * @see #setMaskCheckInverted(boolean)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_MaskCheckInverted()
	 * @model
	 * @generated
	 */
	boolean isMaskCheckInverted();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#isMaskCheckInverted <em>Mask Check Inverted</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mask Check Inverted</em>' attribute.
	 * @see #isMaskCheckInverted()
	 * @generated
	 */
	void setMaskCheckInverted(boolean value);

	/**
	 * Returns the value of the '<em><b>Mask In Hex</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mask In Hex</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mask In Hex</em>' attribute.
	 * @see #setMaskInHex(String)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_MaskInHex()
	 * @model
	 * @generated
	 */
	String getMaskInHex();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getMaskInHex <em>Mask In Hex</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mask In Hex</em>' attribute.
	 * @see #getMaskInHex()
	 * @generated
	 */
	void setMaskInHex(String value);

	/**
	 * Returns the value of the '<em><b>Mask Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mask Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mask Value</em>' attribute.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_MaskValue()
	 * @model changeable="false"
	 * @generated
	 */
	int getMaskValue();

	/**
	 * Returns the value of the '<em><b>Fault Delay</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Fault Delay</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Fault Delay</em>' attribute.
	 * @see #setFaultDelay(int)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getCondition_FaultDelay()
	 * @model
	 * @generated
	 */
	int getFaultDelay();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getFaultDelay <em>Fault Delay</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Fault Delay</em>' attribute.
	 * @see #getFaultDelay()
	 * @generated
	 */
	void setFaultDelay(int value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ConditionStatus check();

} // Condition
