/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.statemachine.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import ch.thomson.ucs.tine.client.statemachine.Condition;
import ch.thomson.ucs.tine.client.statemachine.ConditionStatus;
import ch.thomson.ucs.tine.client.statemachine.Setting;
import ch.thomson.ucs.tine.client.statemachine.State;
import ch.thomson.ucs.tine.client.statemachine.StatemachineFactory;
import ch.thomson.ucs.tine.client.statemachine.StatemachinePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Condition</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getState <em>State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getMaskInHex <em>Mask In Hex</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getMaskValue <em>Mask Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getFaultDelay <em>Fault Delay</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getMinCondition <em>Min Condition</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getMaxCondition <em>Max Condition</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getLastAlarmMessage <em>Last Alarm Message</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getAlarmMessageKeyMask <em>Alarm Message Key Mask</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getActualConditionStatus <em>Actual Condition Status</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getLastConditionStatus <em>Last Condition Status</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getAlarmMessageKeyMax <em>Alarm Message Key Max</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#getAlarmMessageKeyMin <em>Alarm Message Key Min</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.ConditionImpl#isMaskCheckInverted <em>Mask Check Inverted</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ConditionImpl extends PropertyDecoratorImpl implements Condition {
	/**
	 * The default value of the '{@link #getMaskInHex() <em>Mask In Hex</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaskInHex()
	 * @generated
	 * @ordered
	 */
	protected static final String MASK_IN_HEX_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getMaskInHex() <em>Mask In Hex</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaskInHex()
	 * @generated
	 * @ordered
	 */
	protected String maskInHex = MASK_IN_HEX_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaskValue() <em>Mask Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaskValue()
	 * @generated
	 * @ordered
	 */
	protected static final int MASK_VALUE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getMaskValue() <em>Mask Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaskValue()
	 * @generated
	 * @ordered
	 */
	protected int maskValue = MASK_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getFaultDelay() <em>Fault Delay</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFaultDelay()
	 * @generated
	 * @ordered
	 */
	protected static final int FAULT_DELAY_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getFaultDelay() <em>Fault Delay</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFaultDelay()
	 * @generated
	 * @ordered
	 */
	protected int faultDelay = FAULT_DELAY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMinCondition() <em>Min Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinCondition()
	 * @generated
	 * @ordered
	 */
	protected Setting minCondition;

	/**
	 * The cached value of the '{@link #getMaxCondition() <em>Max Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxCondition()
	 * @generated
	 * @ordered
	 */
	protected Setting maxCondition;

	/**
	 * The default value of the '{@link #getLastAlarmMessage() <em>Last Alarm Message</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLastAlarmMessage()
	 * @generated
	 * @ordered
	 */
	protected static final String LAST_ALARM_MESSAGE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLastAlarmMessage() <em>Last Alarm Message</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLastAlarmMessage()
	 * @generated
	 * @ordered
	 */
	protected String lastAlarmMessage = LAST_ALARM_MESSAGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getAlarmMessageKeyMask() <em>Alarm Message Key Mask</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarmMessageKeyMask()
	 * @generated
	 * @ordered
	 */
	protected static final String ALARM_MESSAGE_KEY_MASK_EDEFAULT = "UNDEFINED";

	/**
	 * The cached value of the '{@link #getAlarmMessageKeyMask() <em>Alarm Message Key Mask</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarmMessageKeyMask()
	 * @generated
	 * @ordered
	 */
	protected String alarmMessageKeyMask = ALARM_MESSAGE_KEY_MASK_EDEFAULT;

	/**
	 * The default value of the '{@link #getActualConditionStatus() <em>Actual Condition Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualConditionStatus()
	 * @generated
	 * @ordered
	 */
	protected static final ConditionStatus ACTUAL_CONDITION_STATUS_EDEFAULT = ConditionStatus.OK;

	/**
	 * The cached value of the '{@link #getActualConditionStatus() <em>Actual Condition Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualConditionStatus()
	 * @generated
	 * @ordered
	 */
	protected ConditionStatus actualConditionStatus = ACTUAL_CONDITION_STATUS_EDEFAULT;

	/**
	 * The default value of the '{@link #getLastConditionStatus() <em>Last Condition Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLastConditionStatus()
	 * @generated
	 * @ordered
	 */
	protected static final ConditionStatus LAST_CONDITION_STATUS_EDEFAULT = ConditionStatus.OK;

	/**
	 * The cached value of the '{@link #getLastConditionStatus() <em>Last Condition Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLastConditionStatus()
	 * @generated
	 * @ordered
	 */
	protected ConditionStatus lastConditionStatus = LAST_CONDITION_STATUS_EDEFAULT;

	/**
	 * The default value of the '{@link #getAlarmMessageKeyMax() <em>Alarm Message Key Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarmMessageKeyMax()
	 * @generated
	 * @ordered
	 */
	protected static final String ALARM_MESSAGE_KEY_MAX_EDEFAULT = "UNDEFINED";

	/**
	 * The cached value of the '{@link #getAlarmMessageKeyMax() <em>Alarm Message Key Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarmMessageKeyMax()
	 * @generated
	 * @ordered
	 */
	protected String alarmMessageKeyMax = ALARM_MESSAGE_KEY_MAX_EDEFAULT;

	/**
	 * The default value of the '{@link #getAlarmMessageKeyMin() <em>Alarm Message Key Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarmMessageKeyMin()
	 * @generated
	 * @ordered
	 */
	protected static final String ALARM_MESSAGE_KEY_MIN_EDEFAULT = "UNDEFINED";

	/**
	 * The cached value of the '{@link #getAlarmMessageKeyMin() <em>Alarm Message Key Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarmMessageKeyMin()
	 * @generated
	 * @ordered
	 */
	protected String alarmMessageKeyMin = ALARM_MESSAGE_KEY_MIN_EDEFAULT;

	/**
	 * The default value of the '{@link #isMaskCheckInverted() <em>Mask Check Inverted</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMaskCheckInverted()
	 * @generated
	 * @ordered
	 */
	protected static final boolean MASK_CHECK_INVERTED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isMaskCheckInverted() <em>Mask Check Inverted</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMaskCheckInverted()
	 * @generated
	 * @ordered
	 */
	protected boolean maskCheckInverted = MASK_CHECK_INVERTED_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StatemachinePackage.Literals.CONDITION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getState() {
		if (eContainerFeatureID() != StatemachinePackage.CONDITION__STATE) return null;
		return (State)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetState(State newState, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newState, StatemachinePackage.CONDITION__STATE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setState(State newState) {
		if (newState != eInternalContainer() || (eContainerFeatureID() != StatemachinePackage.CONDITION__STATE && newState != null)) {
			if (EcoreUtil.isAncestor(this, newState))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newState != null)
				msgs = ((InternalEObject)newState).eInverseAdd(this, StatemachinePackage.STATE__CONDITIONS, State.class, msgs);
			msgs = basicSetState(newState, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__STATE, newState, newState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Setting getMinCondition() {
		if(minCondition == null) {
			this.setMinCondition(StatemachineFactory.eINSTANCE.createSetting());
		}
		return minCondition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMinCondition(Setting newMinCondition, NotificationChain msgs) {
		Setting oldMinCondition = minCondition;
		minCondition = newMinCondition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__MIN_CONDITION, oldMinCondition, newMinCondition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMinCondition(Setting newMinCondition) {
		if (newMinCondition != minCondition) {
			NotificationChain msgs = null;
			if (minCondition != null)
				msgs = ((InternalEObject)minCondition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.CONDITION__MIN_CONDITION, null, msgs);
			if (newMinCondition != null)
				msgs = ((InternalEObject)newMinCondition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.CONDITION__MIN_CONDITION, null, msgs);
			msgs = basicSetMinCondition(newMinCondition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__MIN_CONDITION, newMinCondition, newMinCondition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Setting getMaxCondition() {
		if(maxCondition == null) {
			this.setMaxCondition(StatemachineFactory.eINSTANCE.createSetting());
		}
		return maxCondition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMaxCondition(Setting newMaxCondition, NotificationChain msgs) {
		Setting oldMaxCondition = maxCondition;
		maxCondition = newMaxCondition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__MAX_CONDITION, oldMaxCondition, newMaxCondition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxCondition(Setting newMaxCondition) {
		if (newMaxCondition != maxCondition) {
			NotificationChain msgs = null;
			if (maxCondition != null)
				msgs = ((InternalEObject)maxCondition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.CONDITION__MAX_CONDITION, null, msgs);
			if (newMaxCondition != null)
				msgs = ((InternalEObject)newMaxCondition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.CONDITION__MAX_CONDITION, null, msgs);
			msgs = basicSetMaxCondition(newMaxCondition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__MAX_CONDITION, newMaxCondition, newMaxCondition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLastAlarmMessage() {
		return lastAlarmMessage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAlarmMessageKeyMask() {
		return alarmMessageKeyMask;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAlarmMessageKeyMask(String newAlarmMessageKeyMask) {
		String oldAlarmMessageKeyMask = alarmMessageKeyMask;
		alarmMessageKeyMask = newAlarmMessageKeyMask;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MASK, oldAlarmMessageKeyMask, alarmMessageKeyMask));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConditionStatus getActualConditionStatus() {
		return actualConditionStatus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConditionStatus getLastConditionStatus() {
		return lastConditionStatus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAlarmMessageKeyMax() {
		return alarmMessageKeyMax;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAlarmMessageKeyMax(String newAlarmMessageKeyMax) {
		String oldAlarmMessageKeyMax = alarmMessageKeyMax;
		alarmMessageKeyMax = newAlarmMessageKeyMax;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MAX, oldAlarmMessageKeyMax, alarmMessageKeyMax));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAlarmMessageKeyMin() {
		return alarmMessageKeyMin;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAlarmMessageKeyMin(String newAlarmMessageKeyMin) {
		String oldAlarmMessageKeyMin = alarmMessageKeyMin;
		alarmMessageKeyMin = newAlarmMessageKeyMin;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MIN, oldAlarmMessageKeyMin, alarmMessageKeyMin));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isMaskCheckInverted() {
		return maskCheckInverted;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaskCheckInverted(boolean newMaskCheckInverted) {
		boolean oldMaskCheckInverted = maskCheckInverted;
		maskCheckInverted = newMaskCheckInverted;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__MASK_CHECK_INVERTED, oldMaskCheckInverted, maskCheckInverted));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMaskInHex() {
		return maskInHex;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaskInHex(String newMaskInHex) {
		String oldMaskInHex = maskInHex;
		maskInHex = newMaskInHex;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__MASK_IN_HEX, oldMaskInHex, maskInHex));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getMaskValue() {
		return maskValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getFaultDelay() {
		return faultDelay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFaultDelay(int newFaultDelay) {
		int oldFaultDelay = faultDelay;
		faultDelay = newFaultDelay;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.CONDITION__FAULT_DELAY, oldFaultDelay, faultDelay));
	}
	
	protected ConditionStatus internalLastConditionStatus = ConditionStatus.OK;
	protected long faultTime;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public ConditionStatus check(){
		boolean fault = false;
		
		
		// Min-Max-Check oder maskierter Check?
		if(!maskedCondition) {
			// Wenn Min-berwachung aktiv -> checken
			if((getMinCondition().getValue() != null) && (getProperty().getFloat() < getMinCondition().getValue())) {
				fault = true;
				lastAlarmMessage = this.getAlarmMessageKeyMin();
			}
			
			// Wenn Max-berwachung aktiv -> checken
			if((getMaxCondition().getValue() != null) && (getProperty().getFloat() > getMaxCondition().getValue())) {
				fault = true;
				lastAlarmMessage = this.getAlarmMessageKeyMax();
			}
		}
		
		else {
			if(this.isMaskCheckInverted()) {
				fault = !((getProperty().getInt() & getMaskValue()) == 0);
				lastAlarmMessage = this.getAlarmMessageKeyMask();
			}
			
			else {
				fault = !((getProperty().getInt() & getMaskValue()) == getMaskValue());
				lastAlarmMessage = this.getAlarmMessageKeyMask();
			}
		}
		
		
		ConditionStatus result = fault ? ConditionStatus.FAULT : ConditionStatus.OK;
		
		// Fehler-Event detektieren (bergang OK zu Fault)
		if(ConditionStatus.OK.equals(internalLastConditionStatus) && ConditionStatus.FAULT.equals(result)) {
			faultTime = System.currentTimeMillis();
		}
		
		internalLastConditionStatus = result;
		
		// berwachungsverzgerung aktiv?
		if(ConditionStatus.FAULT.equals(result)) {
			// Solange Timer NICHT abgelaufen, Status OK melden
			if((System.currentTimeMillis() - faultTime) < getFaultDelay()) {
				result = ConditionStatus.OK;
			}
		}
		
		this.lastConditionStatus = this.actualConditionStatus;
		this.actualConditionStatus = result;
		
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StatemachinePackage.CONDITION__STATE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetState((State)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StatemachinePackage.CONDITION__STATE:
				return basicSetState(null, msgs);
			case StatemachinePackage.CONDITION__MIN_CONDITION:
				return basicSetMinCondition(null, msgs);
			case StatemachinePackage.CONDITION__MAX_CONDITION:
				return basicSetMaxCondition(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case StatemachinePackage.CONDITION__STATE:
				return eInternalContainer().eInverseRemove(this, StatemachinePackage.STATE__CONDITIONS, State.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StatemachinePackage.CONDITION__STATE:
				return getState();
			case StatemachinePackage.CONDITION__MASK_IN_HEX:
				return getMaskInHex();
			case StatemachinePackage.CONDITION__MASK_VALUE:
				return getMaskValue();
			case StatemachinePackage.CONDITION__FAULT_DELAY:
				return getFaultDelay();
			case StatemachinePackage.CONDITION__MIN_CONDITION:
				return getMinCondition();
			case StatemachinePackage.CONDITION__MAX_CONDITION:
				return getMaxCondition();
			case StatemachinePackage.CONDITION__LAST_ALARM_MESSAGE:
				return getLastAlarmMessage();
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MASK:
				return getAlarmMessageKeyMask();
			case StatemachinePackage.CONDITION__ACTUAL_CONDITION_STATUS:
				return getActualConditionStatus();
			case StatemachinePackage.CONDITION__LAST_CONDITION_STATUS:
				return getLastConditionStatus();
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MAX:
				return getAlarmMessageKeyMax();
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MIN:
				return getAlarmMessageKeyMin();
			case StatemachinePackage.CONDITION__MASK_CHECK_INVERTED:
				return isMaskCheckInverted();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StatemachinePackage.CONDITION__STATE:
				setState((State)newValue);
				return;
			case StatemachinePackage.CONDITION__MASK_IN_HEX:
				setMaskInHex((String)newValue);
				return;
			case StatemachinePackage.CONDITION__FAULT_DELAY:
				setFaultDelay((Integer)newValue);
				return;
			case StatemachinePackage.CONDITION__MIN_CONDITION:
				setMinCondition((Setting)newValue);
				return;
			case StatemachinePackage.CONDITION__MAX_CONDITION:
				setMaxCondition((Setting)newValue);
				return;
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MASK:
				setAlarmMessageKeyMask((String)newValue);
				return;
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MAX:
				setAlarmMessageKeyMax((String)newValue);
				return;
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MIN:
				setAlarmMessageKeyMin((String)newValue);
				return;
			case StatemachinePackage.CONDITION__MASK_CHECK_INVERTED:
				setMaskCheckInverted((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StatemachinePackage.CONDITION__STATE:
				setState((State)null);
				return;
			case StatemachinePackage.CONDITION__MASK_IN_HEX:
				setMaskInHex(MASK_IN_HEX_EDEFAULT);
				return;
			case StatemachinePackage.CONDITION__FAULT_DELAY:
				setFaultDelay(FAULT_DELAY_EDEFAULT);
				return;
			case StatemachinePackage.CONDITION__MIN_CONDITION:
				setMinCondition((Setting)null);
				return;
			case StatemachinePackage.CONDITION__MAX_CONDITION:
				setMaxCondition((Setting)null);
				return;
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MASK:
				setAlarmMessageKeyMask(ALARM_MESSAGE_KEY_MASK_EDEFAULT);
				return;
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MAX:
				setAlarmMessageKeyMax(ALARM_MESSAGE_KEY_MAX_EDEFAULT);
				return;
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MIN:
				setAlarmMessageKeyMin(ALARM_MESSAGE_KEY_MIN_EDEFAULT);
				return;
			case StatemachinePackage.CONDITION__MASK_CHECK_INVERTED:
				setMaskCheckInverted(MASK_CHECK_INVERTED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StatemachinePackage.CONDITION__STATE:
				return getState() != null;
			case StatemachinePackage.CONDITION__MASK_IN_HEX:
				return MASK_IN_HEX_EDEFAULT == null ? maskInHex != null : !MASK_IN_HEX_EDEFAULT.equals(maskInHex);
			case StatemachinePackage.CONDITION__MASK_VALUE:
				return maskValue != MASK_VALUE_EDEFAULT;
			case StatemachinePackage.CONDITION__FAULT_DELAY:
				return faultDelay != FAULT_DELAY_EDEFAULT;
			case StatemachinePackage.CONDITION__MIN_CONDITION:
				return minCondition != null;
			case StatemachinePackage.CONDITION__MAX_CONDITION:
				return maxCondition != null;
			case StatemachinePackage.CONDITION__LAST_ALARM_MESSAGE:
				return LAST_ALARM_MESSAGE_EDEFAULT == null ? lastAlarmMessage != null : !LAST_ALARM_MESSAGE_EDEFAULT.equals(lastAlarmMessage);
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MASK:
				return ALARM_MESSAGE_KEY_MASK_EDEFAULT == null ? alarmMessageKeyMask != null : !ALARM_MESSAGE_KEY_MASK_EDEFAULT.equals(alarmMessageKeyMask);
			case StatemachinePackage.CONDITION__ACTUAL_CONDITION_STATUS:
				return actualConditionStatus != ACTUAL_CONDITION_STATUS_EDEFAULT;
			case StatemachinePackage.CONDITION__LAST_CONDITION_STATUS:
				return lastConditionStatus != LAST_CONDITION_STATUS_EDEFAULT;
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MAX:
				return ALARM_MESSAGE_KEY_MAX_EDEFAULT == null ? alarmMessageKeyMax != null : !ALARM_MESSAGE_KEY_MAX_EDEFAULT.equals(alarmMessageKeyMax);
			case StatemachinePackage.CONDITION__ALARM_MESSAGE_KEY_MIN:
				return ALARM_MESSAGE_KEY_MIN_EDEFAULT == null ? alarmMessageKeyMin != null : !ALARM_MESSAGE_KEY_MIN_EDEFAULT.equals(alarmMessageKeyMin);
			case StatemachinePackage.CONDITION__MASK_CHECK_INVERTED:
				return maskCheckInverted != MASK_CHECK_INVERTED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (maskInHex: ");
		result.append(maskInHex);
		result.append(", maskValue: ");
		result.append(maskValue);
		result.append(", faultDelay: ");
		result.append(faultDelay);
		result.append(", lastAlarmMessage: ");
		result.append(lastAlarmMessage);
		result.append(", alarmMessageKeyMask: ");
		result.append(alarmMessageKeyMask);
		result.append(", actualConditionStatus: ");
		result.append(actualConditionStatus);
		result.append(", lastConditionStatus: ");
		result.append(lastConditionStatus);
		result.append(", alarmMessageKeyMax: ");
		result.append(alarmMessageKeyMax);
		result.append(", alarmMessageKeyMin: ");
		result.append(alarmMessageKeyMin);
		result.append(", maskCheckInverted: ");
		result.append(maskCheckInverted);
		result.append(')');
		return result.toString();
	}
	
	private boolean maskedCondition = false;

	@Override
	public void initialize() throws Exception {
		super.initialize();
		
		this.getMaxCondition().initialize();
		this.getMinCondition().initialize();
		
		if (this.getMaskInHex() != null) {
			try {
				this.maskValue = Integer.parseInt(getMaskInHex(), 16);
				maskedCondition = true;
			} catch (NumberFormatException e) {
				throw new Exception(e);
			}
		}		
	}

} //ConditionImpl
