/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import ch.thomson.ucs.tine.client.ClientPackage;
import ch.thomson.ucs.tine.client.PropertyGroup;
import ch.thomson.ucs.tine.client.PropertyTine;
import ch.thomson.ucs.tine.client.util.Activator;
import de.desy.tine.client.TLink;
import de.desy.tine.client.TLinkCallback;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TAccess;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TMode;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Tine Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getMinimum <em>Minimum</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getMaximum <em>Maximum</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getUnit <em>Unit</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getDecimalPlaces <em>Decimal Places</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getValue <em>Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#isWritable <em>Writable</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getLinkStatus <em>Link Status</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getLinkErrorCode <em>Link Error Code</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getTimeStamp <em>Time Stamp</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getServerHost <em>Server Host</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getLogonLevel <em>Logon Level</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getPath <em>Path</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getTLink <em>TLink</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getTLinkCallback <em>TLink Callback</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getLength <em>Length</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getPropertyGroup <em>Property Group</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getInDataType <em>In Data Type</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getOutDataType <em>Out Data Type</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#isGroupMember <em>Group Member</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#isScheduled <em>Scheduled</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.PropertyTineImpl#getRefreshRate <em>Refresh Rate</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class PropertyTineImpl extends EObjectImpl implements PropertyTine {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getMinimum() <em>Minimum</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinimum()
	 * @generated
	 * @ordered
	 */
	protected static final float MINIMUM_EDEFAULT = 0.0F;

	/**
	 * The cached value of the '{@link #getMinimum() <em>Minimum</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinimum()
	 * @generated
	 * @ordered
	 */
	protected float minimum = MINIMUM_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaximum() <em>Maximum</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaximum()
	 * @generated
	 * @ordered
	 */
	protected static final float MAXIMUM_EDEFAULT = 0.0F;

	/**
	 * The cached value of the '{@link #getMaximum() <em>Maximum</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaximum()
	 * @generated
	 * @ordered
	 */
	protected float maximum = MAXIMUM_EDEFAULT;

	/**
	 * The default value of the '{@link #getUnit() <em>Unit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnit()
	 * @generated
	 * @ordered
	 */
	protected static final String UNIT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUnit() <em>Unit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnit()
	 * @generated
	 * @ordered
	 */
	protected String unit = UNIT_EDEFAULT;

	/**
	 * The default value of the '{@link #getDecimalPlaces() <em>Decimal Places</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDecimalPlaces()
	 * @generated
	 * @ordered
	 */
	protected static final int DECIMAL_PLACES_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getDecimalPlaces() <em>Decimal Places</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDecimalPlaces()
	 * @generated
	 * @ordered
	 */
	protected int decimalPlaces = DECIMAL_PLACES_EDEFAULT;

	/**
	 * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValue()
	 * @generated
	 * @ordered
	 */
	protected static final Object VALUE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getValue() <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValue()
	 * @generated
	 * @ordered
	 */
	protected Object value = VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #isWritable() <em>Writable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWritable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean WRITABLE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isWritable() <em>Writable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWritable()
	 * @generated
	 * @ordered
	 */
	protected boolean writable = WRITABLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getLinkStatus() <em>Link Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkStatus()
	 * @generated
	 * @ordered
	 */
	protected static final String LINK_STATUS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLinkStatus() <em>Link Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkStatus()
	 * @generated
	 * @ordered
	 */
	protected String linkStatus = LINK_STATUS_EDEFAULT;

	/**
	 * The default value of the '{@link #getLinkErrorCode() <em>Link Error Code</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkErrorCode()
	 * @generated
	 * @ordered
	 */
	protected static final int LINK_ERROR_CODE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getLinkErrorCode() <em>Link Error Code</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkErrorCode()
	 * @generated
	 * @ordered
	 */
	protected int linkErrorCode = LINK_ERROR_CODE_EDEFAULT;

	/**
	 * The default value of the '{@link #getTimeStamp() <em>Time Stamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeStamp()
	 * @generated
	 * @ordered
	 */
	protected static final long TIME_STAMP_EDEFAULT = 0L;

	/**
	 * The default value of the '{@link #getServerHost() <em>Server Host</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getServerHost()
	 * @generated
	 * @ordered
	 */
	protected static final String SERVER_HOST_EDEFAULT = null;

	/**
	 * The default value of the '{@link #getLogonLevel() <em>Logon Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLogonLevel()
	 * @generated
	 * @ordered
	 */
	protected static final int LOGON_LEVEL_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getLogonLevel() <em>Logon Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLogonLevel()
	 * @generated
	 * @ordered
	 */
	protected int logonLevel = LOGON_LEVEL_EDEFAULT;

	/**
	 * The default value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected static final String PATH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected String path = PATH_EDEFAULT;

	/**
	 * The default value of the '{@link #getTLink() <em>TLink</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTLink()
	 * @generated
	 * @ordered
	 */
	protected static final TLink TLINK_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTLink() <em>TLink</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTLink()
	 * @generated
	 * @ordered
	 */
	protected TLink tLink = TLINK_EDEFAULT;

	/**
	 * The default value of the '{@link #getTLinkCallback() <em>TLink Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTLinkCallback()
	 * @generated
	 * @ordered
	 */
	protected static final TLinkCallback TLINK_CALLBACK_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTLinkCallback() <em>TLink Callback</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTLinkCallback()
	 * @generated
	 * @ordered
	 */
	protected TLinkCallback tLinkCallback = TLINK_CALLBACK_EDEFAULT;

	/**
	 * The default value of the '{@link #getLength() <em>Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLength()
	 * @generated
	 * @ordered
	 */
	protected static final int LENGTH_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getLength() <em>Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLength()
	 * @generated
	 * @ordered
	 */
	protected int length = LENGTH_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPropertyGroup() <em>Property Group</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPropertyGroup()
	 * @generated
	 * @ordered
	 */
	protected PropertyGroup propertyGroup;

	/**
	 * The default value of the '{@link #getInDataType() <em>In Data Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInDataType()
	 * @generated
	 * @ordered
	 */
	protected static final TDataType IN_DATA_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getInDataType() <em>In Data Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInDataType()
	 * @generated
	 * @ordered
	 */
	protected TDataType inDataType = IN_DATA_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getOutDataType() <em>Out Data Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutDataType()
	 * @generated
	 * @ordered
	 */
	protected static final TDataType OUT_DATA_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOutDataType() <em>Out Data Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutDataType()
	 * @generated
	 * @ordered
	 */
	protected TDataType outDataType = OUT_DATA_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #isGroupMember() <em>Group Member</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isGroupMember()
	 * @generated
	 * @ordered
	 */
	protected static final boolean GROUP_MEMBER_EDEFAULT = false;

	/**
	 * The default value of the '{@link #isScheduled() <em>Scheduled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isScheduled()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SCHEDULED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isScheduled() <em>Scheduled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isScheduled()
	 * @generated
	 * @ordered
	 */
	protected boolean scheduled = SCHEDULED_EDEFAULT;

	/**
	 * The default value of the '{@link #getRefreshRate() <em>Refresh Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRefreshRate()
	 * @generated
	 * @ordered
	 */
	protected static final int REFRESH_RATE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getRefreshRate() <em>Refresh Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRefreshRate()
	 * @generated
	 * @ordered
	 */
	protected int refreshRate = REFRESH_RATE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyTineImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ClientPackage.Literals.PROPERTY_TINE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getMinimum() {
		return minimum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMinimum(float newMinimum) {
		float oldMinimum = minimum;
		minimum = newMinimum;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__MINIMUM, oldMinimum, minimum));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getMaximum() {
		return maximum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaximum(float newMaximum) {
		float oldMaximum = maximum;
		maximum = newMaximum;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__MAXIMUM, oldMaximum, maximum));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUnit() {
		return unit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnit(String newUnit) {
		String oldUnit = unit;
		unit = newUnit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__UNIT, oldUnit, unit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getDecimalPlaces() {
		return decimalPlaces;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDecimalPlaces(int newDecimalPlaces) {
		int oldDecimalPlaces = decimalPlaces;
		decimalPlaces = newDecimalPlaces;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__DECIMAL_PLACES, oldDecimalPlaces, decimalPlaces));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setValue(Object newValue) {
		if(((ClientImpl) this.eContainer()).isInitialized() && unparseTineData(newValue)) {			
			// An Tine Server bermitteln
			TLink tLink = new TLink(getPath(), getName(), null, getInDataType(), TAccess.CA_WRITE);
			long time = System.currentTimeMillis();
			int result = tLink.executeAndClose(5000);
			Activator.getLogger().info("[" + Thread.currentThread().getName() + "] " + "Write TINE " + (getPath() + "/" + this.getName() + ": " + this.getValueAsString(newValue)) + ", linkExecTime=" + (System.currentTimeMillis()-time) + "ms");
			setLinkErrorCode(result);
			setLinkStatus(tLink.getLastError().trim());
			if(result != 0)
				Activator.getLogger().error("[" + Thread.currentThread().getName() + "] " + "Write data " + getValueAsString(newValue) + " to " + getPath() + "/" + getName() + " failed: " + tLink.getLastError().trim());
		}
		
		else {
			Object oldValue = value;
			value = newValue;
			Activator.getLogger().info("[" + Thread.currentThread().getName() + "] " + "Write EMF " + (getPath() + "/" + this.getName() + ": " + this.getValueAsString(newValue)));
			if (eNotificationRequired())
				eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__VALUE, oldValue, value));
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isWritable() {
		return writable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLinkStatus() {
		return linkStatus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLinkStatus(String newLinkStatus) {
		String oldLinkStatus = linkStatus;
		linkStatus = newLinkStatus;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__LINK_STATUS, oldLinkStatus, linkStatus));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getLinkErrorCode() {
		return linkErrorCode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLinkErrorCode(int newLinkErrorCode) {
		int oldLinkErrorCode = linkErrorCode;
		linkErrorCode = newLinkErrorCode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__LINK_ERROR_CODE, oldLinkErrorCode, linkErrorCode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public long getTimeStamp() {
		return this.getOutDataType().getDataTimeStamp();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public String getServerHost() {
		// Adresse des zustndigen TINE Servers ermitteln
		TLink tLink = new TLink(this.getPath(), this.getName());
		String host = tLink.srvAddr.fecAddr.fecHost.getHostAddress();
		tLink.close();
		return host;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getLogonLevel() {
		return logonLevel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLogonLevel(int newLogonLevel) {
		int oldLogonLevel = logonLevel;
		logonLevel = newLogonLevel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__LOGON_LEVEL, oldLogonLevel, logonLevel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPath() {
		return path;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPath(String newPath) {
		String oldPath = path;
		path = newPath;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__PATH, oldPath, path));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TLink getTLink() {
		return tLink;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public TLinkCallback getTLinkCallback() {
		if(tLinkCallback == TLINK_CALLBACK_EDEFAULT) {
			tLinkCallback = new TLinkCallback(){
				
				private int lastLinkStatus = TErrorList.success;
				
				@Override
				public void callback(TLink link) {
					setLinkErrorCode(link.getLinkStatus());
					setLinkStatus(TErrorList.getErrorString(link.getLinkStatus()));
					
					// Linkstatus gendert?
					if(link.getLinkStatus() != lastLinkStatus) {
						lastLinkStatus = link.getLinkStatus();
						if(lastLinkStatus != TErrorList.success)
							Activator.getLogger().error(link + ": " + getLinkStatus());
						else
							Activator.getLogger().info(link + " reconnected");
					}
					parseTineData(getOutDataType());
				}
			};
		}
		
		return tLinkCallback;
	}
	
	private synchronized void parseTineData(TDataType dout) {
		try {
			ignoreNotification = true; // Write Adapter soll nicht auf die nderung reagieren
			unpackData(dout);
		} catch (Exception e) {
			Activator.getLogger().error(e);
		} finally {
			ignoreNotification = false;
		}
	}
	
	private synchronized boolean unparseTineData(Object newValue) {
		if(ignoreNotification) {
			return false;
		}
		
		try {
			packData(getInDataType(), newValue);
		} catch (Exception e) {
			Activator.getLogger().error(e);
			return false;
		}
		return true;	
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getLength() {
		return length;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLength(int newLength) {
		int oldLength = length;
		length = newLength;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__LENGTH, oldLength, length));
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyGroup getPropertyGroup() {
		if (propertyGroup != null && propertyGroup.eIsProxy()) {
			InternalEObject oldPropertyGroup = (InternalEObject)propertyGroup;
			propertyGroup = (PropertyGroup)eResolveProxy(oldPropertyGroup);
			if (propertyGroup != oldPropertyGroup) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ClientPackage.PROPERTY_TINE__PROPERTY_GROUP, oldPropertyGroup, propertyGroup));
			}
		}
		return propertyGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyGroup basicGetPropertyGroup() {
		return propertyGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPropertyGroup(PropertyGroup newPropertyGroup) {
		PropertyGroup oldPropertyGroup = propertyGroup;
		propertyGroup = newPropertyGroup;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__PROPERTY_GROUP, oldPropertyGroup, propertyGroup));
	}

	protected boolean ignoreNotification = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void initialize() throws Exception {
		
		// Wenn nicht durch eine Blockproperty abgehandelt, initialisieren und AttachLink anmelden
		if (!isGroupMember()) {
			tLink = new TLink(this.getPath(), this.getName(), this.getOutDataType(), null, TAccess.CA_READ);		
			
			int mode = TMode.CM_DATACHANGE | TMode.CM_WAIT;
			int rate = getRefreshRate();
			
			if(isScheduled()) {
				mode = TMode.CM_EVENT | TMode.CM_WAIT;
				rate = 30000; // 30s, braucht es nur um die Verbindung auf Unterbruch zu prfen
			}
			
			// AttachLink (asynchron) anmelden und warten, bis die Daten das 1. Mal empfangen wurden
			if (tLink.attach(mode, getTLinkCallback(), rate) < 0) {
				throw new Exception("Attach Link failed: " + tLink.getLastError());
			}
		}	
	}	
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public TDataType getInDataType() {
		if(inDataType == null)
			inDataType = createTDataType();
		return inDataType;
	}

	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public TDataType getOutDataType() {
		if(outDataType == null)
			outDataType = createTDataType();
		return outDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isGroupMember() {
		return this.getPropertyGroup() != null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isScheduled() {
		return scheduled;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setScheduled(boolean newScheduled) {
		boolean oldScheduled = scheduled;
		scheduled = newScheduled;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__SCHEDULED, oldScheduled, scheduled));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getRefreshRate() {
		return refreshRate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRefreshRate(int newRefreshRate) {
		int oldRefreshRate = refreshRate;
		refreshRate = newRefreshRate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ClientPackage.PROPERTY_TINE__REFRESH_RATE, oldRefreshRate, refreshRate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setWritable(boolean writable) {
		this.writable = writable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract void packData(TDataType tData, Object data);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract void unpackData(TDataType data);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract String getValueAsString(Object newValue);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract TDataType createTDataType();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract void setValueForce(Object newValue);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ClientPackage.PROPERTY_TINE__NAME:
				return getName();
			case ClientPackage.PROPERTY_TINE__DESCRIPTION:
				return getDescription();
			case ClientPackage.PROPERTY_TINE__MINIMUM:
				return getMinimum();
			case ClientPackage.PROPERTY_TINE__MAXIMUM:
				return getMaximum();
			case ClientPackage.PROPERTY_TINE__UNIT:
				return getUnit();
			case ClientPackage.PROPERTY_TINE__DECIMAL_PLACES:
				return getDecimalPlaces();
			case ClientPackage.PROPERTY_TINE__VALUE:
				return getValue();
			case ClientPackage.PROPERTY_TINE__WRITABLE:
				return isWritable();
			case ClientPackage.PROPERTY_TINE__LINK_STATUS:
				return getLinkStatus();
			case ClientPackage.PROPERTY_TINE__LINK_ERROR_CODE:
				return getLinkErrorCode();
			case ClientPackage.PROPERTY_TINE__TIME_STAMP:
				return getTimeStamp();
			case ClientPackage.PROPERTY_TINE__SERVER_HOST:
				return getServerHost();
			case ClientPackage.PROPERTY_TINE__LOGON_LEVEL:
				return getLogonLevel();
			case ClientPackage.PROPERTY_TINE__PATH:
				return getPath();
			case ClientPackage.PROPERTY_TINE__TLINK:
				return getTLink();
			case ClientPackage.PROPERTY_TINE__TLINK_CALLBACK:
				return getTLinkCallback();
			case ClientPackage.PROPERTY_TINE__LENGTH:
				return getLength();
			case ClientPackage.PROPERTY_TINE__PROPERTY_GROUP:
				if (resolve) return getPropertyGroup();
				return basicGetPropertyGroup();
			case ClientPackage.PROPERTY_TINE__IN_DATA_TYPE:
				return getInDataType();
			case ClientPackage.PROPERTY_TINE__OUT_DATA_TYPE:
				return getOutDataType();
			case ClientPackage.PROPERTY_TINE__GROUP_MEMBER:
				return isGroupMember();
			case ClientPackage.PROPERTY_TINE__SCHEDULED:
				return isScheduled();
			case ClientPackage.PROPERTY_TINE__REFRESH_RATE:
				return getRefreshRate();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ClientPackage.PROPERTY_TINE__NAME:
				setName((String)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__MINIMUM:
				setMinimum((Float)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__MAXIMUM:
				setMaximum((Float)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__UNIT:
				setUnit((String)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__DECIMAL_PLACES:
				setDecimalPlaces((Integer)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__VALUE:
				setValue(newValue);
				return;
			case ClientPackage.PROPERTY_TINE__LINK_STATUS:
				setLinkStatus((String)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__LINK_ERROR_CODE:
				setLinkErrorCode((Integer)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__LOGON_LEVEL:
				setLogonLevel((Integer)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__PATH:
				setPath((String)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__LENGTH:
				setLength((Integer)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__PROPERTY_GROUP:
				setPropertyGroup((PropertyGroup)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__SCHEDULED:
				setScheduled((Boolean)newValue);
				return;
			case ClientPackage.PROPERTY_TINE__REFRESH_RATE:
				setRefreshRate((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ClientPackage.PROPERTY_TINE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__MINIMUM:
				setMinimum(MINIMUM_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__MAXIMUM:
				setMaximum(MAXIMUM_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__UNIT:
				setUnit(UNIT_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__DECIMAL_PLACES:
				setDecimalPlaces(DECIMAL_PLACES_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__VALUE:
				setValue(VALUE_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__LINK_STATUS:
				setLinkStatus(LINK_STATUS_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__LINK_ERROR_CODE:
				setLinkErrorCode(LINK_ERROR_CODE_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__LOGON_LEVEL:
				setLogonLevel(LOGON_LEVEL_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__PATH:
				setPath(PATH_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__LENGTH:
				setLength(LENGTH_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__PROPERTY_GROUP:
				setPropertyGroup((PropertyGroup)null);
				return;
			case ClientPackage.PROPERTY_TINE__SCHEDULED:
				setScheduled(SCHEDULED_EDEFAULT);
				return;
			case ClientPackage.PROPERTY_TINE__REFRESH_RATE:
				setRefreshRate(REFRESH_RATE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ClientPackage.PROPERTY_TINE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ClientPackage.PROPERTY_TINE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case ClientPackage.PROPERTY_TINE__MINIMUM:
				return minimum != MINIMUM_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__MAXIMUM:
				return maximum != MAXIMUM_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__UNIT:
				return UNIT_EDEFAULT == null ? unit != null : !UNIT_EDEFAULT.equals(unit);
			case ClientPackage.PROPERTY_TINE__DECIMAL_PLACES:
				return decimalPlaces != DECIMAL_PLACES_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__VALUE:
				return VALUE_EDEFAULT == null ? value != null : !VALUE_EDEFAULT.equals(value);
			case ClientPackage.PROPERTY_TINE__WRITABLE:
				return writable != WRITABLE_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__LINK_STATUS:
				return LINK_STATUS_EDEFAULT == null ? linkStatus != null : !LINK_STATUS_EDEFAULT.equals(linkStatus);
			case ClientPackage.PROPERTY_TINE__LINK_ERROR_CODE:
				return linkErrorCode != LINK_ERROR_CODE_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__TIME_STAMP:
				return getTimeStamp() != TIME_STAMP_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__SERVER_HOST:
				return SERVER_HOST_EDEFAULT == null ? getServerHost() != null : !SERVER_HOST_EDEFAULT.equals(getServerHost());
			case ClientPackage.PROPERTY_TINE__LOGON_LEVEL:
				return logonLevel != LOGON_LEVEL_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__PATH:
				return PATH_EDEFAULT == null ? path != null : !PATH_EDEFAULT.equals(path);
			case ClientPackage.PROPERTY_TINE__TLINK:
				return TLINK_EDEFAULT == null ? tLink != null : !TLINK_EDEFAULT.equals(tLink);
			case ClientPackage.PROPERTY_TINE__TLINK_CALLBACK:
				return TLINK_CALLBACK_EDEFAULT == null ? tLinkCallback != null : !TLINK_CALLBACK_EDEFAULT.equals(tLinkCallback);
			case ClientPackage.PROPERTY_TINE__LENGTH:
				return length != LENGTH_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__PROPERTY_GROUP:
				return propertyGroup != null;
			case ClientPackage.PROPERTY_TINE__IN_DATA_TYPE:
				return IN_DATA_TYPE_EDEFAULT == null ? inDataType != null : !IN_DATA_TYPE_EDEFAULT.equals(inDataType);
			case ClientPackage.PROPERTY_TINE__OUT_DATA_TYPE:
				return OUT_DATA_TYPE_EDEFAULT == null ? outDataType != null : !OUT_DATA_TYPE_EDEFAULT.equals(outDataType);
			case ClientPackage.PROPERTY_TINE__GROUP_MEMBER:
				return isGroupMember() != GROUP_MEMBER_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__SCHEDULED:
				return scheduled != SCHEDULED_EDEFAULT;
			case ClientPackage.PROPERTY_TINE__REFRESH_RATE:
				return refreshRate != REFRESH_RATE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", minimum: ");
		result.append(minimum);
		result.append(", maximum: ");
		result.append(maximum);
		result.append(", unit: ");
		result.append(unit);
		result.append(", decimalPlaces: ");
		result.append(decimalPlaces);
		result.append(", value: ");
		result.append(value);
		result.append(", writable: ");
		result.append(writable);
		result.append(", linkStatus: ");
		result.append(linkStatus);
		result.append(", linkErrorCode: ");
		result.append(linkErrorCode);
		result.append(", logonLevel: ");
		result.append(logonLevel);
		result.append(", path: ");
		result.append(path);
		result.append(", tLink: ");
		result.append(tLink);
		result.append(", tLinkCallback: ");
		result.append(tLinkCallback);
		result.append(", length: ");
		result.append(length);
		result.append(", inDataType: ");
		result.append(inDataType);
		result.append(", outDataType: ");
		result.append(outDataType);
		result.append(", scheduled: ");
		result.append(scheduled);
		result.append(", refreshRate: ");
		result.append(refreshRate);
		result.append(')');
		return result.toString();
	}

} //TinePropertyImpl
