package ch.thomson.ucs.tine.server.util;

import org.eclipse.core.runtime.Platform;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

import ch.thomson.ucs.utils.logging.IPluginLogger;
import ch.thomson.ucs.utils.logging.Log4jTransfer;
import ch.thomson.ucs.utils.logging.PluginLogger;

public class Activator implements BundleActivator {

	private static BundleContext context;
	private static IPluginLogger logger;
	
	@Override
	public void start(BundleContext context) throws Exception {
		Activator.context = context;
		
		// Logger initialisieren
		Platform.addLogListener(Log4jTransfer.getInstance());
		logger = PluginLogger.getLogger(context.getBundle());
	}

	@Override
	public void stop(BundleContext context) throws Exception {

	}

	public static BundleContext getContext() {
		return context;
	}

	public static IPluginLogger getLogger() {
		return logger;
	}
}
