package de.desy.tine.stringUtils;

import de.desy.tine.types.NAME;

public class NameToString
{
  public static String[] nameArrayToString(NAME[] inputArray)
  {
    if (inputArray == null) return null;
    return nameArrayToString(inputArray, inputArray.length);
  }
  public static String[] nameArrayToString(NAME[] inputArray,int length)
  {
    if (length > 0)
    {
      String[] rv = new String[length];
      for (int i = 0; i < length; i++)
      {
        rv[i] = inputArray[i] != null ? inputArray[i].getName() : "";
      }
      return rv;
    }
    return new String[]{""};
  }
}
