#!/bin/bash

# Checke, ob das Skript als root ausgefhrt wird
if [ $EUID -ne 0 ]; then
  echo "You must be a root user!!!" 2>&1
  exit 1
fi

# TineServer ersetzen
if [ -d /opt/TineServer ]; then 
	echo "try to stop TineServer"
	/etc/init.d/tineserver stop
	echo $?
	if [ -d /opt/TineServer_old ]; then 
		rm -R /opt/TineServer_old
	fi
	mv /opt/TineServer /opt/TineServer_old
fi
cp -p -R TineServer /opt

# GUI ersetzen
if [ -d /opt/GUI ]; then
	if [ -d /opt/GUI_old ]; then 
		rm -R /opt/GUI_old
	fi
	mv /opt/GUI /opt/GUI_old
fi
cp -p -R GUI /opt

# ucs.ini kopieren, falls nicht vorhanden
if [ ! -f /usr/etc/tine/ucs.ini ]; then 
	cp -p ucs.ini /usr/etc/tine
	chmod 644 /usr/etc/tine/ucs.ini
fi

# TINE Server starten
/etc/init.d/tineserver start
if [ $?  -ne  0 ]; then
	echo "Start TineServer failed"
	exit 1
else
	echo "TineServer started successully"
fi