package ch.thomson.ucs.alarms.client.dao.entries;

import java.sql.Timestamp;

/**
 * Diese Klasse ist im Moment noch identisch mit AlarmPendingEntry, weshalb sie
 * von dieser Klasse erbt und nichts weiter hinzufgt.
 * 
 * @author FischerU
 * 
 */
public class AlarmHistoryEntry extends AlarmPendingEntry {

	public AlarmHistoryEntry(Timestamp timestamp, String id, String eqm, String category, String descriptor, String message) {
		super(timestamp, id, eqm, category, descriptor, message);
	}
	
	public AlarmHistoryEntry(long timestamp, String id, String eqm, String category, String descriptor) {
		super(timestamp, id, eqm, category, descriptor);
	}
	
	@Override
	public boolean equals(Object obj) {
		if(this == obj)
			return true;
		if (obj == null)
	        return false;
	    if (getClass() != obj.getClass())
	        return false;
	    
	    AlarmHistoryEntry other = (AlarmHistoryEntry) obj;
		if(!id.equals(other.id))
			return false;
		
		if(!descriptor.equals(other.descriptor))
			return false;
		
		return true;
	}
}
