package ch.thomson.ucs.desy.specialfunctions;

import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

public class CopyPropertyObserved extends SpecialFunctionPropertyObserved {
	protected PropertyNumericDAO result;
	
	public CopyPropertyObserved(String from, String to) throws Exception {
		PropertyNumericDAO pnFrom = this.addObservedProperty(from);
		result = PropertyNumericDAO.createPropertyNumericDAO(to, false);
		this.refresh(pnFrom, pnFrom.getValuesAsFloat(), new float[pnFrom.getLength()]);
	}
	
	@Override
	protected void refresh(PropertyNumericDAO property, float[] newValues, float[] oldValues) {
		result.setValuesAsFloat(newValues);
	}
}
