package ch.thomson.ucs.desy.specialfunctions.fastchannel;

import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Sample;


public class PulseActPowerSelection extends PulseActSelection {

	protected Sample pnSamplesCurrent;
	
	public PulseActPowerSelection(FastChannelCalculationSet parent, String actTrigger, String samplesVolt, String samplesCurrent, String result) throws Exception {
		super(parent, actTrigger, samplesVolt, result);
		
		pnSamplesCurrent = this.findSample(samplesCurrent);		
	}

	@Override
	public void refresh() {
		float[] samplesVolt = pnSamples.getCachedValues();
		float[] samplesCurrent = pnSamplesCurrent.getCachedValues();
		pnResult.setResult(samplesVolt[pnActTrigger.getCachedValueInt()]/*[kV]*/ * samplesCurrent[pnActTrigger.getCachedValueInt()] / 1000.0f); // Resultat in MW
	}
}
