package ch.thomson.swing.graphics;

import java.awt.Color;


/**
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public interface IGraphicStroke {

	/**
	 * Gibt die Liniendicke in Pixel zurck
	 * 
	 * @return Die Liniendicke in px
	 */
	public abstract int getSizeLine();

	/**
	 * Setzt die Liniendicke in Pixel
	 * 
	 * @param sizeLine in px
	 */
	public abstract void setSizeLine(int sizeLine);

	/**
	 * Gibt die Farbe der Linie zurck
	 * 
	 * @return <b>Color</b> der Linie
	 */
	public abstract Color getLineColor();

	/**
	 * Setzt die Farbe der Linie
	 * 
	 * @param lineColor ein <b>Color</b> Objekt
	 */
	public abstract void setLineColor(Color lineColor);
}