package ch.thomson.swing.jlabel;

import java.awt.Color;
import java.awt.Graphics;

import ch.thomson.swing.graphics.IGraphicsScaleRectangular;
import ch.thomson.swing.graphics.impl.GraphicsScaleRectangular;


/**
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public class JLabelScaleRectangular extends JLabelBase implements IGraphicsScaleRectangular{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected GraphicsScaleRectangular SymbolAntennaSwitch = null;
	
	
	protected GraphicsScaleRectangular getScaleRectangular(){
		if(SymbolAntennaSwitch == null){
			SymbolAntennaSwitch = new GraphicsScaleRectangular(getHeight(), getWidth());
			SymbolAntennaSwitch.setParent(this);
		}
		return SymbolAntennaSwitch;
	}

	@Override
	public void paint(Graphics g) {
		Base = getScaleRectangular();
		super.paint(g);
	}

	@Override
	public int getInterval() {
		return getScaleRectangular().getInterval();
	}

	@Override
	public int[] getTicks() {
		return getScaleRectangular().getTicks();
	}

	@Override
	public int getTicks(int index) {
		return getScaleRectangular().getTicks(index);
	}

	@Override
	public Color[] getTicksColor() {
		return getScaleRectangular().getTicksColor();
	}

	@Override
	public Color getTicksColor(int index) {
		return getScaleRectangular().getTicksColor(index);
	}

	@Override
	public int[] getTicksLength() {
		return getScaleRectangular().getTicksLength();
	}

	@Override
	public int getTicksLength(int index) {
		return getScaleRectangular().getTicksLength(index);
	}

	@Override
	public int[] getTicksPosition() {
		return getScaleRectangular().getTicksPosition();
	}

	@Override
	public int getTicksPosition(int index) {
		return getScaleRectangular().getTicksPosition(index);
	}

	@Override
	public int[] getTicksSize() {
		return getScaleRectangular().getTicksSize();
	}

	@Override
	public int getTicksSize(int index) {
		return getScaleRectangular().getTicksSize(index);
	}

	@Override
	public boolean isCorrectLength() {
		return getScaleRectangular().isCorrectLength();
	}

	@Override
	public boolean isVisibleAxis() {
		return getScaleRectangular().isVisibleAxis();
	}

	@Override
	public void setCorrectLength(boolean correctLength) {
		getScaleRectangular().setCorrectLength(correctLength);
	}

	@Override
	public void setInterval(int interval) {
		getScaleRectangular().setInterval(interval);
	}

	@Override
	public void setTicks(int[] ticks) {
		getScaleRectangular().setTicks(ticks);		
	}

	@Override
	public void setTicks(int index, int value) {
		getScaleRectangular().setTicks(index, value);
	}

	@Override
	public void setTicksColor(Color[] ticksColor) {
		getScaleRectangular().setTicksColor(ticksColor);
	}

	@Override
	public void setTicksColor(int index, Color value) {
		getScaleRectangular().setTicksColor(index, value);
	}

	@Override
	public void setTicksLength(int[] ticksLength) {
		getScaleRectangular().setTicksLength(ticksLength);
	}

	@Override
	public void setTicksLength(int index, int value) {
		getScaleRectangular().setTicksLength(index, value);
	}

	@Override
	public void setTicksPosition(int[] ticksPosition) {
		getScaleRectangular().setTicksPosition(ticksPosition);
	}

	@Override
	public void setTicksPosition(int index, int value) {
		getScaleRectangular().setTicksPosition(index, value);
	}

	@Override
	public void setTicksSize(int[] ticksSize) {
		getScaleRectangular().setTicksSize(ticksSize);
	}

	@Override
	public void setTicksSize(int index, int value) {
		getScaleRectangular().setTicksSize(index, value);
	}

	@Override
	public void setVisibleAxis(boolean visibleAxis) {
		getScaleRectangular().setVisibleAxis(visibleAxis);
	}

	@Override
	public int getPosition() {
		return getScaleRectangular().getPosition();
	}

	@Override
	public void setPosition(int position) {
		getScaleRectangular().setPosition(position);
	}

	@Override
	public Color getLineColor() {
		return getScaleRectangular().getLineColor();
	}

	@Override
	public int getSizeLine() {
		return getScaleRectangular().getSizeLine();
	}

	@Override
	public void setLineColor(Color lineColor) {
		getScaleRectangular().setLineColor(lineColor);
	}

	@Override
	public void setSizeLine(int sizeLine) {
		getScaleRectangular().setSizeLine(sizeLine);
	}

	@Override
	public int getOrientation() {
		return getScaleRectangular().getOrientation();
	}

	@Override
	public void setOrientation(int orientation) {
		getScaleRectangular().setOrientation(orientation);
	}

	@Override
	public Color getFillColor() {
		return getScaleRectangular().getFillColor();
	}

	@Override
	public void setFillColor(Color fillColor) {
		getScaleRectangular().setFillColor(fillColor);
	}
}
