package ch.thomson.ucs.tine.client.databinding.converters;

import ch.thomson.ucs.tine.client.Property;

public class StringToString extends IndexedConverter {

	public StringToString(int index, Property property) {
		// Index ist bei Strings immer 0
		super(String.class, String.class, 0, property);
	}

	@Override
	public Object convert(Object fromObject) {
		// Es gibt nichts zu konvertieren
		return fromObject;
	}

	@Override
	public int getIndex() {
		// Index ist bei Strings immer 0
		return 0;
	}

	@Override
	public void setIndex(int index) {
		// Nichts machen, Strings haben keinen Index im EMF-Modell
	}
	
	
}
