package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;

import ch.thomson.ucs.tine.client.Client;

public class ThGroup extends Group implements IComposite {

	private Client client;
	
	public ThGroup(Composite parent, int style) {
		super(parent, style);
	}
	
	@Override
	protected void checkSubclass() {}
	
	public Client getClient() {
		return this.client;
	}

	@Override
	public void initialize(Client client) throws Exception {
		this.client = client;
		for(Control c : this.getChildren()) {
			if(c instanceof IDataBinding) {
				((IDataBinding) c).bindValues(this.client);
			}
		}
	}
}
