/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.statemachine.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import ch.thomson.ucs.alarms.StatemachineAlarmVectorHandler;
import ch.thomson.ucs.tine.client.statemachine.Condition;
import ch.thomson.ucs.tine.client.statemachine.ConditionStatus;
import ch.thomson.ucs.tine.client.statemachine.State;
import ch.thomson.ucs.tine.client.statemachine.StateMachine;
import ch.thomson.ucs.tine.client.statemachine.StateStatus;
import ch.thomson.ucs.tine.client.statemachine.StatemachinePackage;
import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>State Machine</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getStates <em>States</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getTinePathTargetState <em>Tine Path Target State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getTinePathActualState <em>Tine Path Actual State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getInitialState <em>Initial State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getActualState <em>Actual State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getWorkerThread <em>Worker Thread</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getWorkerThreadSleepingTime <em>Worker Thread Sleeping Time</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getTargetStateProperty <em>Target State Property</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateMachineImpl#getActualStateProperty <em>Actual State Property</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StateMachineImpl extends StateMachineObjectImpl implements StateMachine {
	/**
	 * The cached value of the '{@link #getStates() <em>States</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStates()
	 * @generated
	 * @ordered
	 */
	protected EList<State> states;

	/**
	 * The default value of the '{@link #getTinePathTargetState() <em>Tine Path Target State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTinePathTargetState()
	 * @generated
	 * @ordered
	 */
	protected static final String TINE_PATH_TARGET_STATE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTinePathTargetState() <em>Tine Path Target State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTinePathTargetState()
	 * @generated
	 * @ordered
	 */
	protected String tinePathTargetState = TINE_PATH_TARGET_STATE_EDEFAULT;

	/**
	 * The default value of the '{@link #getTinePathActualState() <em>Tine Path Actual State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTinePathActualState()
	 * @generated
	 * @ordered
	 */
	protected static final String TINE_PATH_ACTUAL_STATE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTinePathActualState() <em>Tine Path Actual State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTinePathActualState()
	 * @generated
	 * @ordered
	 */
	protected String tinePathActualState = TINE_PATH_ACTUAL_STATE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInitialState() <em>Initial State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialState()
	 * @generated
	 * @ordered
	 */
	protected State initialState;

	/**
	 * The cached value of the '{@link #getActualState() <em>Actual State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualState()
	 * @generated
	 * @ordered
	 */
	protected State actualState;

	/**
	 * The default value of the '{@link #getWorkerThread() <em>Worker Thread</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWorkerThread()
	 * @generated
	 * @ordered
	 */
	protected static final Thread WORKER_THREAD_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getWorkerThread() <em>Worker Thread</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWorkerThread()
	 * @generated
	 * @ordered
	 */
	protected Thread workerThread = WORKER_THREAD_EDEFAULT;

	/**
	 * The default value of the '{@link #getWorkerThreadSleepingTime() <em>Worker Thread Sleeping Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWorkerThreadSleepingTime()
	 * @generated
	 * @ordered
	 */
	protected static final int WORKER_THREAD_SLEEPING_TIME_EDEFAULT = 10;

	/**
	 * The cached value of the '{@link #getWorkerThreadSleepingTime() <em>Worker Thread Sleeping Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWorkerThreadSleepingTime()
	 * @generated
	 * @ordered
	 */
	protected int workerThreadSleepingTime = WORKER_THREAD_SLEEPING_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #getTargetStateProperty() <em>Target State Property</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetStateProperty()
	 * @generated
	 * @ordered
	 */
	protected static final PropertyNumericDAO TARGET_STATE_PROPERTY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTargetStateProperty() <em>Target State Property</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetStateProperty()
	 * @generated
	 * @ordered
	 */
	protected PropertyNumericDAO targetStateProperty = TARGET_STATE_PROPERTY_EDEFAULT;

	/**
	 * The default value of the '{@link #getActualStateProperty() <em>Actual State Property</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualStateProperty()
	 * @generated
	 * @ordered
	 */
	protected static final PropertyNumericDAO ACTUAL_STATE_PROPERTY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getActualStateProperty() <em>Actual State Property</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualStateProperty()
	 * @generated
	 * @ordered
	 */
	protected PropertyNumericDAO actualStateProperty = ACTUAL_STATE_PROPERTY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StateMachineImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StatemachinePackage.Literals.STATE_MACHINE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<State> getStates() {
		if (states == null) {
			states = new EObjectContainmentWithInverseEList<State>(State.class, this, StatemachinePackage.STATE_MACHINE__STATES, StatemachinePackage.STATE__STATE_MACHINE);
		}
		return states;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTinePathTargetState() {
		return tinePathTargetState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTinePathTargetState(String newTinePathTargetState) {
		String oldTinePathTargetState = tinePathTargetState;
		tinePathTargetState = newTinePathTargetState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE_MACHINE__TINE_PATH_TARGET_STATE, oldTinePathTargetState, tinePathTargetState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTinePathActualState() {
		return tinePathActualState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTinePathActualState(String newTinePathActualState) {
		String oldTinePathActualState = tinePathActualState;
		tinePathActualState = newTinePathActualState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE_MACHINE__TINE_PATH_ACTUAL_STATE, oldTinePathActualState, tinePathActualState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyNumericDAO getTargetStateProperty() {
		return targetStateProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyNumericDAO getActualStateProperty() {
		return actualStateProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getInitialState() {
		if (initialState != null && initialState.eIsProxy()) {
			InternalEObject oldInitialState = (InternalEObject)initialState;
			initialState = (State)eResolveProxy(oldInitialState);
			if (initialState != oldInitialState) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, StatemachinePackage.STATE_MACHINE__INITIAL_STATE, oldInitialState, initialState));
			}
		}
		return initialState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State basicGetInitialState() {
		return initialState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInitialState(State newInitialState) {
		State oldInitialState = initialState;
		initialState = newInitialState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE_MACHINE__INITIAL_STATE, oldInitialState, initialState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getActualState() {
		if (actualState != null && actualState.eIsProxy()) {
			InternalEObject oldActualState = (InternalEObject)actualState;
			actualState = (State)eResolveProxy(oldActualState);
			if (actualState != oldActualState) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, StatemachinePackage.STATE_MACHINE__ACTUAL_STATE, oldActualState, actualState));
			}
		}
		return actualState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State basicGetActualState() {
		return actualState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setActualState(State newActualState) {
		State oldActualState = actualState;
		actualState = newActualState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE_MACHINE__ACTUAL_STATE, oldActualState, actualState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Thread getWorkerThread() {
		return workerThread;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getWorkerThreadSleepingTime() {
		return workerThreadSleepingTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setWorkerThreadSleepingTime(int newWorkerThreadSleepingTime) {
		int oldWorkerThreadSleepingTime = workerThreadSleepingTime;
		workerThreadSleepingTime = newWorkerThreadSleepingTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE_MACHINE__WORKER_THREAD_SLEEPING_TIME, oldWorkerThreadSleepingTime, workerThreadSleepingTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void run() {
		this.getWorkerThread().start();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void shutdown() {
		this.getInitialState().stop();
		this.getWorkerThread().interrupt();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StatemachinePackage.STATE_MACHINE__STATES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getStates()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StatemachinePackage.STATE_MACHINE__STATES:
				return ((InternalEList<?>)getStates()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StatemachinePackage.STATE_MACHINE__STATES:
				return getStates();
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_TARGET_STATE:
				return getTinePathTargetState();
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_ACTUAL_STATE:
				return getTinePathActualState();
			case StatemachinePackage.STATE_MACHINE__INITIAL_STATE:
				if (resolve) return getInitialState();
				return basicGetInitialState();
			case StatemachinePackage.STATE_MACHINE__ACTUAL_STATE:
				if (resolve) return getActualState();
				return basicGetActualState();
			case StatemachinePackage.STATE_MACHINE__WORKER_THREAD:
				return getWorkerThread();
			case StatemachinePackage.STATE_MACHINE__WORKER_THREAD_SLEEPING_TIME:
				return getWorkerThreadSleepingTime();
			case StatemachinePackage.STATE_MACHINE__TARGET_STATE_PROPERTY:
				return getTargetStateProperty();
			case StatemachinePackage.STATE_MACHINE__ACTUAL_STATE_PROPERTY:
				return getActualStateProperty();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StatemachinePackage.STATE_MACHINE__STATES:
				getStates().clear();
				getStates().addAll((Collection<? extends State>)newValue);
				return;
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_TARGET_STATE:
				setTinePathTargetState((String)newValue);
				return;
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_ACTUAL_STATE:
				setTinePathActualState((String)newValue);
				return;
			case StatemachinePackage.STATE_MACHINE__INITIAL_STATE:
				setInitialState((State)newValue);
				return;
			case StatemachinePackage.STATE_MACHINE__ACTUAL_STATE:
				setActualState((State)newValue);
				return;
			case StatemachinePackage.STATE_MACHINE__WORKER_THREAD_SLEEPING_TIME:
				setWorkerThreadSleepingTime((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StatemachinePackage.STATE_MACHINE__STATES:
				getStates().clear();
				return;
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_TARGET_STATE:
				setTinePathTargetState(TINE_PATH_TARGET_STATE_EDEFAULT);
				return;
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_ACTUAL_STATE:
				setTinePathActualState(TINE_PATH_ACTUAL_STATE_EDEFAULT);
				return;
			case StatemachinePackage.STATE_MACHINE__INITIAL_STATE:
				setInitialState((State)null);
				return;
			case StatemachinePackage.STATE_MACHINE__ACTUAL_STATE:
				setActualState((State)null);
				return;
			case StatemachinePackage.STATE_MACHINE__WORKER_THREAD_SLEEPING_TIME:
				setWorkerThreadSleepingTime(WORKER_THREAD_SLEEPING_TIME_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StatemachinePackage.STATE_MACHINE__STATES:
				return states != null && !states.isEmpty();
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_TARGET_STATE:
				return TINE_PATH_TARGET_STATE_EDEFAULT == null ? tinePathTargetState != null : !TINE_PATH_TARGET_STATE_EDEFAULT.equals(tinePathTargetState);
			case StatemachinePackage.STATE_MACHINE__TINE_PATH_ACTUAL_STATE:
				return TINE_PATH_ACTUAL_STATE_EDEFAULT == null ? tinePathActualState != null : !TINE_PATH_ACTUAL_STATE_EDEFAULT.equals(tinePathActualState);
			case StatemachinePackage.STATE_MACHINE__INITIAL_STATE:
				return initialState != null;
			case StatemachinePackage.STATE_MACHINE__ACTUAL_STATE:
				return actualState != null;
			case StatemachinePackage.STATE_MACHINE__WORKER_THREAD:
				return WORKER_THREAD_EDEFAULT == null ? workerThread != null : !WORKER_THREAD_EDEFAULT.equals(workerThread);
			case StatemachinePackage.STATE_MACHINE__WORKER_THREAD_SLEEPING_TIME:
				return workerThreadSleepingTime != WORKER_THREAD_SLEEPING_TIME_EDEFAULT;
			case StatemachinePackage.STATE_MACHINE__TARGET_STATE_PROPERTY:
				return TARGET_STATE_PROPERTY_EDEFAULT == null ? targetStateProperty != null : !TARGET_STATE_PROPERTY_EDEFAULT.equals(targetStateProperty);
			case StatemachinePackage.STATE_MACHINE__ACTUAL_STATE_PROPERTY:
				return ACTUAL_STATE_PROPERTY_EDEFAULT == null ? actualStateProperty != null : !ACTUAL_STATE_PROPERTY_EDEFAULT.equals(actualStateProperty);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (tinePathTargetState: ");
		result.append(tinePathTargetState);
		result.append(", tinePathActualState: ");
		result.append(tinePathActualState);
		result.append(", workerThread: ");
		result.append(workerThread);
		result.append(", workerThreadSleepingTime: ");
		result.append(workerThreadSleepingTime);
		result.append(", targetStateProperty: ");
		result.append(targetStateProperty);
		result.append(", actualStateProperty: ");
		result.append(actualStateProperty);
		result.append(')');
		return result.toString();
	}
	
	private class WorkerThread extends Thread {
		private StateMachine stateMachine;
		
		public WorkerThread(StateMachine stateMachine) {
			this.stateMachine = stateMachine;
			this.setName("StateMachineWorker");
		}

		@Override
		public void run() {
			int sleepingTime = stateMachine.getWorkerThreadSleepingTime();

			while(!isInterrupted()) {
				try {
					Thread.sleep(sleepingTime);
					doWork();
				} catch (InterruptedException e) {
					interrupt();
				}
			}
		}
	}

	@Override
	public void initialize() throws Exception {
		// Property-Verbindungen setzen
		this.targetStateProperty = PropertyNumericDAO.createPropertyNumericDAO(getTinePathTargetState(), true);
		this.actualStateProperty = PropertyNumericDAO.createPropertyNumericDAO(getTinePathActualState(), true);
		
		// Alle States initialisieren
		for(State state : this.getStates()) {
			state.initialize();
		}
		
		// Initialstate starten
		StateStatus stateStatus = this.getInitialState().start();
		if(!stateStatus.equals(StateStatus.OK))
			throw new Exception("Start Initial State " + this.getInitialState() + " failed");
		
		this.setActualState(this.getInitialState());
		iActualState = 0;
		this.getActualStateProperty().setInt(iActualState);
		iTargetState = 0;
		this.getTargetStateProperty().setInt(iTargetState);
		
		this.workerThread = new WorkerThread(this);
	}
	
	private int iActualState = 0;
	private int iTargetState = 0;
	
	private void doWork() {
		// Target State pro Zyklus einmal einlesen und im weiteren Verlauf die Membervariable verwenden
		iTargetState = this.getTargetStateProperty().getInt();
		
		// Check TargetState
		if(iTargetState > iActualState)
			goToNextState();
		
		else if(iTargetState < iActualState)
			goToPreviousState();
		
		// Wenn gilt "actualState == targetState" muss ein schon gestarteter NextState wieder gestoppt werden.
		else if(iTargetState == iActualState) {
			if(startedState != null) {
				startedState.stop();
				startedState = null;
			}
		}
		
		checkActiveStates();
	}
	
	/**
	 * Ermittelt und setzt den Fallback State ausgehend von einem fehlerhaften State.
	 * @param faultyState Fehlerhafter State, der die Rckschaltung auslst.
	 */
	private void setFallBackState(State faultyState) {
		int index = 0;
		int fallBackStateIndex = 0;
		
		// Den nchst tieferen Mainstate ermitteln
		for(State s = this.getInitialState(); s != faultyState; s = s.getNextState()) {
			
			if(s.isMainState())
				fallBackStateIndex = index; // Merke die Position
			
			index++;
		}
		
		// Rckschaltung einleiten
		iTargetState = fallBackStateIndex;
		this.getTargetStateProperty().setInt(iTargetState);
	}
	
	private State faultyState = null;

	
	// TODO: Dynamisch machen
	private StatemachineAlarmVectorHandler alarmHandler;	
	private StatemachineAlarmVectorHandler getAlarmHandler() {
		if(alarmHandler == null) {
			try {
				PropertyNumericDAO property = PropertyNumericDAO.createPropertyNumericDAO("DUMMIES/Device1/ALARM_VECTOR", true);
				alarmHandler = new StatemachineAlarmVectorHandler(property, 0);
			}catch (Exception e) {
				e.printStackTrace();
			}
		}
		return alarmHandler;
	}
	
	/**
	 * Diese Methode muss zyklisch aufgerufen werden. Die States sind ja als
	 * doppelt verkettete Liste vorhanden. Hier wird beginnend beim InitialState
	 * die State-Liste bis und mit aktuellem State oder gestartetem State (falls
	 * ein neuer gestartet wurde) durchlaufen. Bei jedem State wird die check()
	 * Methode aufgerufen und ausgewertet. Im Fehlerfall wird auf den hchst
	 * mglichen (Main-) State zurckgeschaltet.
	 */
	private void checkActiveStates() {
		
		// Testen ob Fehlerrckschalt-State erreicht ist und faultyState wieder lschen
		if(faultyState != null) {
			if(this.getActualState() == faultyState.getPreviousState())
				faultyState = null;
		}

		State s = this.getInitialState();
		
		do {
			StateStatus stateStatus = s.check();
			
			// Fehler erkannt?
			if(stateStatus.equals(StateStatus.FAULT)) {								
				// Wenn der indizierte State der aktuelle Fehlerstate ist, Funktion frhzeitig verlassen
				if(s == faultyState)
					return;
				
				// Merke fehlerhaften State
				faultyState = s;
				
				for(Condition c : s.getActualFaultConditions()) {
					try {
						this.getAlarmHandler().setFault(c.getLastAlarmMessage());
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				
				// Neuer Zielstatus setzen und somit Rckschaltung einleiten
				this.setFallBackState(s);
				
				// Es MUSS zurckgeschaltet werden, deshalb Funktion vorzeitig verlassen
				return; 
			}
			
			// Checke die Warnungen (die knnen kommen und gehen)
			for(Condition c : s.getAllWarningConditions()) {
				// Warnung ist gegangen
				if(ConditionStatus.OK.equals(c.getActualConditionStatus())){
					try {
						String message = c.getLastAlarmMessage();
						if(message != null)
							this.getAlarmHandler().setWarning(message, false);
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			
				// Warnung ist gekommen
				else if(ConditionStatus.FAULT.equals(c.getActualConditionStatus()))
					try {
						String message = c.getLastAlarmMessage();
						if(message != null)
							this.getAlarmHandler().setWarning(message, true);
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}	
			}
			
			// Abbruchbedingung: Aktueller State oder Started State erreicht?
			if((s == this.getActualState() && this.getActualState().getNextState() != startedState) || s == startedState)
				break;
			
			s = s.getNextState();
			
		} while (s != null);
	}
	
	private State startedState = null;
	
	/**
	 * Diese Methode soll solange zyklisch aufgerufen werden, bis der Next State OK zurckmeldet.
	 */
	private void goToNextState() {
		// Target State Bereich berprfen und anpassen (begrenzen auf max. State)
		if(iTargetState >= this.getStates().size()) {
			iTargetState = this.getStates().size() - 1;
			this.getTargetStateProperty().setInt(iTargetState);
		}
		
		if((startedState = getActualState().getNextState()) == null)
			return; // Keinen weiteren State zum Starten
		
		// Nchsten State starten
		StateStatus status = startedState.start();
		
		// Ergebnis auswerten
		switch (status.getValue()) {
		case StateStatus.OK_VALUE:
			setActualState(startedState); // State ist fertig gestartet, wird nun zum aktuellen State
			startedState = null;
			// Aktueller Status = Aktueller Status + 1
			this.getActualStateProperty().setInt(++iActualState);
			break;
		}
	}
	
	/*
	 * Diese Methode soll solange zyklisch aufgerufen werden, bis der Previous State erreicht ist.
	 */
	private void goToPreviousState() {
		// Target State Bereich berprfen und ggf. anpassen
		if(iTargetState < 0) {
			iTargetState = 0;
			this.getTargetStateProperty().setInt(iTargetState);
		}
		
		// Wurde der NextState bereits gestartet? -> Diesen zuerst stoppen, bevor richtig zurckgeschaltet wird
		if(startedState != null) {
			startedState.stop(); // Auswertung wird ignoriert, Hauptsache die Kommandos werden ausgeschaltet TODO: Was ist mit dem Stop-Delay? Im Moment wird das Delay nur abgewaretet, wenn der State vollstndig gestartet wurde.
			startedState = null;
		}
		
		// Aktuellen State stoppen
		else {
			StateStatus status = this.getActualState().stop();

			// Ergebnis auswerten und zurckschalten (TODO: im Moment nur OK-Fall, evtl. noch andere denkbar)
			switch (status.getValue()) {
			case StateStatus.OK_VALUE:
				this.setActualState(this.getActualState().getPreviousState());
				// ActualState = ActualState - 1
				this.getActualStateProperty().setInt(--iActualState);
				break;
			}
		}
	}

} //StateMachineImpl
