package ch.thomson.ucs.tine.server.driver.modbus;

import ch.thomson.ucs.tine.server.Driver;
import ch.thomson.ucs.tine.server.util.IDriverFactory;

public class DriverFactory implements IDriverFactory {

	@Override
	public Driver createDriver() {
		return new ModbusDriver();
	}

	@Override
	public String getDriverType() {
		return "modbus";
	}

}
