/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.nio.ByteBuffer;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.Observer;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.ServerPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Table</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#getObservers <em>Observers</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#getDevice <em>Device</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#getByteBuffer <em>Byte Buffer</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#getAbsoluteAddress <em>Absolute Address</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#isDirty <em>Dirty</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#isWritable <em>Writable</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#isDummy <em>Dummy</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DataTableImpl#isObserverNotificationEnabled <em>Observer Notification Enabled</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DataTableImpl extends EObjectImpl implements DataTable {
	/**
	 * The cached value of the '{@link #getObservers() <em>Observers</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObservers()
	 * @generated
	 * @ordered
	 */
	protected EList<Observer> observers;

	/**
	 * The cached value of the '{@link #getProperties() <em>Properties</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<RealProperty> properties;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;
	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getByteBuffer() <em>Byte Buffer</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getByteBuffer()
	 * @generated
	 * @ordered
	 */
	protected static final ByteBuffer BYTE_BUFFER_EDEFAULT = null;

	/**
	 * The default value of the '{@link #getAbsoluteAddress() <em>Absolute Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAbsoluteAddress()
	 * @generated
	 * @ordered
	 */
	protected static final int ABSOLUTE_ADDRESS_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getAbsoluteAddress() <em>Absolute Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAbsoluteAddress()
	 * @generated
	 * @ordered
	 */
	protected int absoluteAddress = ABSOLUTE_ADDRESS_EDEFAULT;

	/**
	 * The default value of the '{@link #isDirty() <em>Dirty</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDirty()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DIRTY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDirty() <em>Dirty</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDirty()
	 * @generated
	 * @ordered
	 */
	protected boolean dirty = DIRTY_EDEFAULT;

	/**
	 * The default value of the '{@link #isWritable() <em>Writable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWritable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean WRITABLE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isWritable() <em>Writable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWritable()
	 * @generated
	 * @ordered
	 */
	protected boolean writable = WRITABLE_EDEFAULT;

	/**
	 * The default value of the '{@link #isDummy() <em>Dummy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDummy()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DUMMY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDummy() <em>Dummy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDummy()
	 * @generated
	 * @ordered
	 */
	protected boolean dummy = DUMMY_EDEFAULT;

	/**
	 * The default value of the '{@link #isObserverNotificationEnabled() <em>Observer Notification Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isObserverNotificationEnabled()
	 * @generated
	 * @ordered
	 */
	protected static final boolean OBSERVER_NOTIFICATION_ENABLED_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isObserverNotificationEnabled() <em>Observer Notification Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isObserverNotificationEnabled()
	 * @generated
	 * @ordered
	 */
	protected boolean observerNotificationEnabled = OBSERVER_NOTIFICATION_ENABLED_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataTableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.DATA_TABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Observer> getObservers() {
		if (observers == null) {
			observers = new EObjectResolvingEList<Observer>(Observer.class, this, ServerPackage.DATA_TABLE__OBSERVERS);
		}
		return observers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Device getDevice() {
		if (eContainerFeatureID() != ServerPackage.DATA_TABLE__DEVICE) return null;
		return (Device)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDevice(Device newDevice, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newDevice, ServerPackage.DATA_TABLE__DEVICE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDevice(Device newDevice) {
		if (newDevice != eInternalContainer() || (eContainerFeatureID() != ServerPackage.DATA_TABLE__DEVICE && newDevice != null)) {
			if (EcoreUtil.isAncestor(this, newDevice))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newDevice != null)
				msgs = ((InternalEObject)newDevice).eInverseAdd(this, ServerPackage.DEVICE__DATA_TABLES, Device.class, msgs);
			msgs = basicSetDevice(newDevice, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DATA_TABLE__DEVICE, newDevice, newDevice));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<RealProperty> getProperties() {
		if (properties == null) {
			properties = new EObjectResolvingEList<RealProperty>(RealProperty.class, this, ServerPackage.DATA_TABLE__PROPERTIES);
		}
		return properties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DATA_TABLE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public ByteBuffer getByteBuffer() {
		ByteBuffer bb = ByteBuffer.wrap(buffer);
		bb.order(getDevice().getEquipmentModule().getByteOrder().toJavaByteOrderEnum());
		return bb;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getAbsoluteAddress() {
		return absoluteAddress;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDirty() {
		return dirty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDirty(boolean newDirty) {
		boolean oldDirty = dirty;
		dirty = newDirty;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DATA_TABLE__DIRTY, oldDirty, dirty));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isWritable() {
		return writable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDummy() {
		return dummy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isObserverNotificationEnabled() {
		return observerNotificationEnabled;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObserverNotificationEnabled(boolean newObserverNotificationEnabled) {
		boolean oldObserverNotificationEnabled = observerNotificationEnabled;
		observerNotificationEnabled = newObserverNotificationEnabled;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED, oldObserverNotificationEnabled, observerNotificationEnabled));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void write(byte[] buffer, int offset) {
		int realOffset = offset - absoluteAddress;
		for (int i = 0; i < buffer.length && (i + realOffset) < getBuffer().length; i++) {
			getBuffer()[i + realOffset] = buffer[i];
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void read(byte[] buffer, int offset) {
		int realOffset = offset - absoluteAddress;
		System.arraycopy(getBuffer(), realOffset, buffer, 0, buffer.length);
	}
	
	private byte[] buffer;
	private byte[] oldBuffer;
	
	private byte[] getBuffer() {
		return buffer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void initialize() throws Exception {
		int smallestOffset = Integer.MAX_VALUE;
		int highestOffset = Integer.MIN_VALUE;
		this.writable = false;
		
		for (RealProperty prop : getProperties()) {
			// Wenn eine Property schreibbar ist, gilt dies fr die gesamte Tabelle.
			if(prop.isWritable())
				this.writable = true;
			
			// Wenn eine Property dummy ist, gilt dies fr die gesamte Tabelle.
			if(prop.isDummy())
				this.dummy = true;
			
			int offset = prop.getAddressOffset();
			if (offset < smallestOffset)
				smallestOffset = offset;

			if (offset >= highestOffset)
				highestOffset = offset + prop.getByteSize();
		}
		
		buffer = new byte[highestOffset - smallestOffset];
		oldBuffer = buffer.clone();
		absoluteAddress = smallestOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void addObserver(Observer observer) {
		this.getObservers().add(observer);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void removeObserver(Observer observer) {
		this.getObservers().remove(observer);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void notifyObservers() {
		// Alle Properties informieren (z. B. Einzel-Property-Contracts)
		for(RealProperty property : this.getProperties()) {
			if(needsNotification(property)) {
				property.refreshCache(this);
				property.notifyObservers();
			}
		}
		
		oldBuffer = buffer.clone();
		
		if(!isObserverNotificationEnabled())
			return; // Nichts tun
		
		// TODO Evtl. Performancesteigerung durch Zugriffe ber Iterator.
		// Alle sonstigen Observers informieren (z. B. Block Property)
		for(int i=0; i<this.getObservers().size(); ++i) {
			this.getObservers().get(i).update(this);
		}
	}
	
	private boolean needsNotification(RealProperty property) {				
		int realOffset = property.getAddressOffset() - absoluteAddress;		
		
		for(int i = realOffset; i < (realOffset + property.getByteSize()) && i < buffer.length; ++i) {
			if(buffer[i] != oldBuffer[i])
				return true;
		}
		
		return false;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.DATA_TABLE__DEVICE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetDevice((Device)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.DATA_TABLE__DEVICE:
				return basicSetDevice(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ServerPackage.DATA_TABLE__DEVICE:
				return eInternalContainer().eInverseRemove(this, ServerPackage.DEVICE__DATA_TABLES, Device.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.DATA_TABLE__OBSERVERS:
				return getObservers();
			case ServerPackage.DATA_TABLE__DEVICE:
				return getDevice();
			case ServerPackage.DATA_TABLE__PROPERTIES:
				return getProperties();
			case ServerPackage.DATA_TABLE__NAME:
				return getName();
			case ServerPackage.DATA_TABLE__BYTE_BUFFER:
				return getByteBuffer();
			case ServerPackage.DATA_TABLE__ABSOLUTE_ADDRESS:
				return getAbsoluteAddress();
			case ServerPackage.DATA_TABLE__DIRTY:
				return isDirty();
			case ServerPackage.DATA_TABLE__WRITABLE:
				return isWritable();
			case ServerPackage.DATA_TABLE__DUMMY:
				return isDummy();
			case ServerPackage.DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED:
				return isObserverNotificationEnabled();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.DATA_TABLE__OBSERVERS:
				getObservers().clear();
				getObservers().addAll((Collection<? extends Observer>)newValue);
				return;
			case ServerPackage.DATA_TABLE__DEVICE:
				setDevice((Device)newValue);
				return;
			case ServerPackage.DATA_TABLE__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection<? extends RealProperty>)newValue);
				return;
			case ServerPackage.DATA_TABLE__NAME:
				setName((String)newValue);
				return;
			case ServerPackage.DATA_TABLE__DIRTY:
				setDirty((Boolean)newValue);
				return;
			case ServerPackage.DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED:
				setObserverNotificationEnabled((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.DATA_TABLE__OBSERVERS:
				getObservers().clear();
				return;
			case ServerPackage.DATA_TABLE__DEVICE:
				setDevice((Device)null);
				return;
			case ServerPackage.DATA_TABLE__PROPERTIES:
				getProperties().clear();
				return;
			case ServerPackage.DATA_TABLE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ServerPackage.DATA_TABLE__DIRTY:
				setDirty(DIRTY_EDEFAULT);
				return;
			case ServerPackage.DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED:
				setObserverNotificationEnabled(OBSERVER_NOTIFICATION_ENABLED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.DATA_TABLE__OBSERVERS:
				return observers != null && !observers.isEmpty();
			case ServerPackage.DATA_TABLE__DEVICE:
				return getDevice() != null;
			case ServerPackage.DATA_TABLE__PROPERTIES:
				return properties != null && !properties.isEmpty();
			case ServerPackage.DATA_TABLE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ServerPackage.DATA_TABLE__BYTE_BUFFER:
				return BYTE_BUFFER_EDEFAULT == null ? getByteBuffer() != null : !BYTE_BUFFER_EDEFAULT.equals(getByteBuffer());
			case ServerPackage.DATA_TABLE__ABSOLUTE_ADDRESS:
				return absoluteAddress != ABSOLUTE_ADDRESS_EDEFAULT;
			case ServerPackage.DATA_TABLE__DIRTY:
				return dirty != DIRTY_EDEFAULT;
			case ServerPackage.DATA_TABLE__WRITABLE:
				return writable != WRITABLE_EDEFAULT;
			case ServerPackage.DATA_TABLE__DUMMY:
				return dummy != DUMMY_EDEFAULT;
			case ServerPackage.DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED:
				return observerNotificationEnabled != OBSERVER_NOTIFICATION_ENABLED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuilder sb = new StringBuilder();
		sb.append("Device=" + getDevice().getName() + ", ");
		sb.append("Data Table=" + name + ": ");
		sb.append('|');
		for(byte b : getBuffer()) {
			sb.append(String.format("%02x", b));
			sb.append('|');
		}
		
		return sb.toString();
	}

} //DataTableImpl
