package de.desy.acop.video.analysis;

/**
 * 
 * <code>AnalysisType</code> defines the two possible analysis types which are available for selection in the 
 * customizer.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public enum AnalysisType {
	GAUSSIAN,INTERFEROMETER_H,INTERFEROMETER_V;
	
	/* (non-Javadoc)
	 * @see java.lang.Enum#toString()
	 */
	@Override
	public String toString() {
		if (this == GAUSSIAN) return "Gaussian";
		else if (this == INTERFEROMETER_V) return "Interferometer (Vertical)";
		else if (this == INTERFEROMETER_H) return "Interferometer (Horizontal)";
		else return null;
	}
}
