package de.desy.tine.types;

public class KEYVALUE 
{
  private String keyvalue;
  public KEYVALUE(String keyValue)
  {
    keyvalue = keyValue;
  }
  public KEYVALUE(String key,String value)
  {
    if (key == null || key.length() == 0) key = "unknown";
    if (value == null || value.length() == 0) value = "unknown";
    keyvalue = key+": "+value;
  }
  public String getString()
  {
    return keyvalue == null ? "" : keyvalue;
  }
  public void putString(String newKeyValue)
  {
    keyvalue = newKeyValue;
  }
  public String getKey()
  {
    if (keyvalue == null) return null;
    int separator = keyvalue.indexOf(':');
    if (separator < 0) return keyvalue;
    if (separator == 0) return "";
    return keyvalue.substring(0, separator);
  }
  public void setKey(String newKey)
  {
    if (newKey == null || newKey.length() == 0) newKey = "unknown";
    keyvalue = newKey+": "+getValue();
  }
  public String getValue()
  {
    if (keyvalue == null) return null;
    int separator = keyvalue.indexOf(':');
    if (separator < 0) return "";
    return keyvalue.substring(separator);    
  }
  public void setValue(String newValue)
  {
    if (newValue == null || newValue.length() == 0) newValue = "unknown";
    keyvalue = getKey()+": "+newValue;
  }
}
